﻿using Microsoft.Xaml.Behaviors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;

namespace WPFNET5CANVAS.Commands
{
    class ButtonMouseBehaviour : Behavior<Panel>
    {
        // Using a DependencyProperty as the backing store for MyProperty.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty CanvasMouseEventArgsProperty =
            DependencyProperty.Register("CanvasMouseEventArgs", typeof(SpecialMouseArgs<MouseEventArgs>), typeof(ButtonMouseBehaviour), new PropertyMetadata(default(SpecialMouseArgs<MouseEventArgs>)));

        public SpecialMouseArgs<MouseEventArgs> CanvasMouseEventArgs
        {
            get { return (SpecialMouseArgs<MouseEventArgs>)GetValue(CanvasMouseEventArgsProperty); }
            set { SetValue(CanvasMouseEventArgsProperty, value); }
        }

        protected override void OnAttached()
        {
            AssociatedObject.MouseDown += AssociatedObjectButtonMouse;
        }

        protected override void OnDetaching()
        {
            AssociatedObject.MouseDown -= AssociatedObjectButtonMouse;
        }

        private void AssociatedObjectButtonMouse(object sender, MouseEventArgs mouseEventArgs)
        {
            CanvasMouseEventArgs = new SpecialMouseArgs<MouseEventArgs>
            {
                MouseArgs = mouseEventArgs,
                SelectedCanvas = (Canvas)sender
            };
        }
    }
}
