﻿using Microsoft.Xaml.Behaviors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using WPFNET5CANVAS.Commands;

namespace WPFNET5CANVAS.Commands
{
    public class MoveMouseBehaviour : Behavior<Panel>
    {
        public SpecialMouseArgs<MouseEventArgs> CanvasMoveMouseEventArgs
        {
            get { return (SpecialMouseArgs<MouseEventArgs>)GetValue(CanvasMoveMouseEventArgsProperty); }
            set { SetValue(CanvasMoveMouseEventArgsProperty, value); }
        }

        // Using a DependencyProperty as the backing store for MyProperty.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty CanvasMoveMouseEventArgsProperty =
            DependencyProperty.Register("CanvasMoveMouseEventArgs", typeof(SpecialMouseArgs<MouseEventArgs>), typeof(MoveMouseBehaviour), new PropertyMetadata(default(SpecialMouseArgs<MouseEventArgs>)));

        protected override void OnAttached()
        {
            AssociatedObject.MouseMove += AssociatedObjectOnMouseMove;
        }

        protected override void OnDetaching()
        {
            AssociatedObject.MouseMove -= AssociatedObjectOnMouseMove;
        }

        private void AssociatedObjectOnMouseMove(object sender, MouseEventArgs mouseEventArgs)
        {
            CanvasMoveMouseEventArgs = new SpecialMouseArgs<MouseEventArgs>
            {
                MouseArgs = mouseEventArgs,
                SelectedCanvas = (Canvas)sender
            };
        }
    }
}
