﻿using Microsoft.Xaml.Behaviors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;

namespace WPFNET5CANVAS.Commands
{
    public class WheelMouseBehaviour : Behavior<Panel>
    {
        public static readonly DependencyProperty CanvasWhelMouseEventArgsProperty = DependencyProperty.Register(
            "CanvasWheelMouseEventArgs", typeof(SpecialMouseArgs<MouseWheelEventArgs>), typeof(WheelMouseBehaviour), new PropertyMetadata(default(SpecialMouseArgs<MouseWheelEventArgs>)));

        public SpecialMouseArgs<MouseWheelEventArgs> CanvasWheelMouseEventArgs
        {
            get { return (SpecialMouseArgs<MouseWheelEventArgs>)GetValue(CanvasWhelMouseEventArgsProperty); }
            set { SetValue(CanvasWhelMouseEventArgsProperty, value); }
        }

        protected override void OnAttached()
        {
            AssociatedObject.MouseWheel += AssociatedObjectWheelMouse;
        }

        protected override void OnDetaching()
        {
            AssociatedObject.MouseWheel -= AssociatedObjectWheelMouse;
        }

        private void AssociatedObjectWheelMouse(object sender, MouseWheelEventArgs mouseWheelEventArgs)
        {
            CanvasWheelMouseEventArgs = new SpecialMouseArgs<MouseWheelEventArgs>
            {
                MouseArgs = mouseWheelEventArgs,
                SelectedCanvas = (Canvas)sender
            };
        }
    }
}
