﻿using Prism.Commands;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using WPFNET5CANVAS.Commands;

namespace WPFNET5CANVAS.ViewModels
{
    public class MainViewModel
    {
        private Canvas CanvasWindow { get; set; }   // deze word ingeladen door de CanvasLoadedCommand

        public ICommand CanvasLoadedCommand { get; private set; }
        public ICommand CanvasMouseDownCommand { get; private set; }
        public ICommand CanvasMoveMouseCommand { get; private set; }
        public ICommand CanvasWheelMouseCommand { get; private set; }
        
        public MainViewModel()
        {
            CanvasLoadedCommand = new DelegateCommand<Canvas>(Execute_CanvasLoadedCommand, CanExecute_CanvasLoadedCommand);
            CanvasMouseDownCommand = new DelegateCommand<SpecialMouseArgs<MouseEventArgs>>(Execute_CanvasMouseDown, CanExecute_CanvasMouseDown);
            CanvasMoveMouseCommand = new DelegateCommand<SpecialMouseArgs<MouseEventArgs>>(Execute_CanvasMoveMouse, CanExecute_CanvasMoveMouse);
            CanvasWheelMouseCommand = new DelegateCommand<SpecialMouseArgs<MouseWheelEventArgs>>(Execute_CanvasWheelMouse, CanExecute_CanvasWheelMouse);
        }

        private void Execute_CanvasLoadedCommand(Canvas canvas)
        {
            CanvasWindow = canvas;
            MessageBox.Show("LoadedCommand");
        }
        private bool CanExecute_CanvasLoadedCommand(Canvas canvas)
        {
            return true;
        }

        private void Execute_CanvasMouseDown(SpecialMouseArgs<MouseEventArgs> args)
        {
            MessageBox.Show("MouseDownCommand");
        }
        private bool CanExecute_CanvasMouseDown(object args)
        {
            return true;
        }

        private void Execute_CanvasMoveMouse(SpecialMouseArgs<MouseEventArgs> arg)
        {
            MessageBox.Show("MoveMouseCommand");
        }
        private bool CanExecute_CanvasMoveMouse(SpecialMouseArgs<MouseEventArgs> arg)
        {
            return true;
        }

        private void Execute_CanvasWheelMouse(SpecialMouseArgs<MouseWheelEventArgs> arg)
        {
            MessageBox.Show("WheelMouseCommand");
        }
        private bool CanExecute_CanvasWheelMouse(SpecialMouseArgs<MouseWheelEventArgs> arg)
        {
            return true;
        }
    }
}
